diff --git a/game/core/src/main/java/net/minecraft/core/world/World.java b/game/core/src/main/java/net/minecraft/core/world/World.java
index 1f744bec9..b1373963b 100644
--- a/game/core/src/main/java/net/minecraft/core/world/World.java
+++ b/game/core/src/main/java/net/minecraft/core/world/World.java
@@ -685,34 +652,34 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockId(@NotNull final TilePos tilePos, final int id) {
+    public boolean setBlockId(final @NotNull TilePosc tilePos, final int id) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            return this.getChunk(tilePos).setBlockId(tilePos.toChunkTilePos(), id);
+            return this.getChunk(tilePos).setBlockId(new ChunkTilePos(tilePos), id);
         }
     }
 
     @Override
-    public @NotNull Material getBlockMaterial(@NotNull final TilePos tilePos) {
+    public @NotNull Material getBlockMaterial(final @NotNull TilePosc tilePos) {
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (block == null) {
-            return Material.air;
+            return Materials.AIR;
         } else {
             return block.getMaterial();
         }
     }
 
     @Override
-    public int getBlockData(final @NotNull TilePos tilePos) {
+    public int getBlockData(final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getBlockData(tilePos.toChunkTilePos());
+            return this.getChunk(tilePos).getBlockData(new ChunkTilePos(tilePos));
         }
     }
 
-    public boolean setBlockDataNotify(final @NotNull TilePos tilePos, final int data) {
+    public boolean setBlockDataNotify(final @NotNull TilePosc tilePos, final int data) {
         if (this.setBlockData(tilePos, data)) {
             this.markBlockNeedsUpdate(tilePos);
 
@@ -732,16 +699,16 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public boolean setBlockData(final @NotNull TilePos tilePos, final int data) {
+    public boolean setBlockData(final @NotNull TilePosc tilePos, final int data) {
         if (!tilePos.inBounds(this)) {
             return false;
         } else {
-            this.getChunk(tilePos).setBlockData(tilePos.toChunkTilePos(), data);
+            this.getChunk(tilePos).setBlockData(new ChunkTilePos(tilePos), data);
             return true;
         }
     }
 
-    public boolean setBlockIdNotify(final @NotNull TilePos tilePos, final int id) {
+    public boolean setBlockIdNotify(final @NotNull TilePosc tilePos, final int id) {
         if (this.setBlockId(tilePos, id)) {
             this.notifyBlockChange(tilePos, id);
             return true;
@@ -755,7 +722,7 @@ public class World implements MutableWorldSource {
         return this.setBlockIdNotify(new TilePos(x, y, z), id);
     }
 
-    public boolean setBlockIdDataNotify(final @NotNull TilePos tilePos, final int id, final int data) {
+    public boolean setBlockIdDataNotify(final @NotNull TilePosc tilePos, final int id, final int data) {
         if (this.setBlockIdData(tilePos, id, data)) {
             this.notifyBlockChange(tilePos, id);
             return true;
@@ -769,9 +736,9 @@ public class World implements MutableWorldSource {
         return this.setBlockIdDataNotify(new TilePos(x, y, z), id, data);
     }
 
-    public void markBlockNeedsUpdate(final @NotNull TilePos tilePos) {
+    public void markBlockNeedsUpdate(final @NotNull TilePosc tilePos) {
         for (final @NotNull LevelListener listener : this.listeners) {
-            listener.blockChanged(tilePos.x, tilePos.y, tilePos.z);
+            listener.blockChanged(tilePos.x(), tilePos.y(), tilePos.z());
         }
     }
 
@@ -780,7 +747,7 @@ public class World implements MutableWorldSource {
         this.markBlockNeedsUpdate(new TilePos(x, y, z));
     }
 
-    public void notifyBlockChange(final @NotNull TilePos tilePos, final int id) {
+    public void notifyBlockChange(final @NotNull TilePosc tilePos, final int id) {
         this.markBlockNeedsUpdate(tilePos);
         this.notifyBlocksOfNeighborChange(tilePos, id);
     }
@@ -794,9 +761,9 @@ public class World implements MutableWorldSource {
         this.markBlocksDirty(new TilePos(x, Math.min(y0, y1), z), new TilePos(x, Math.max(y0, y1), z));
     }
 
-    public void markBlockDirty(final @NotNull TilePos tilePos) {
+    public void markBlockDirty(final @NotNull TilePosc tilePos) {
         for (final @NotNull LevelListener listener : this.listeners) {
-            listener.setBlocksDirty(tilePos.x, tilePos.y, tilePos.z, tilePos.x, tilePos.y, tilePos.z);
+            listener.setBlocksDirty(tilePos.x(), tilePos.y(), tilePos.z(), tilePos.x(), tilePos.y(), tilePos.z());
         }
     }
 
@@ -805,15 +772,15 @@ public class World implements MutableWorldSource {
         this.markBlockDirty(new TilePos(x, y, z));
     }
 
-    public void markBlocksDirty(final @NotNull TilePos min, final @NotNull TilePos max) {
+    public void markBlocksDirty(final @NotNull TilePosc min, final @NotNull TilePosc max) {
         for (final @NotNull LevelListener listener : this.listeners) {
             listener.setBlocksDirty(
-                Math.min(min.x, max.x),
-                Math.min(min.y, max.y),
-                Math.min(min.z, max.z),
-                Math.max(min.x, max.x),
-                Math.max(min.y, max.y),
-                Math.max(min.z, max.z)
+                Math.min(min.x(), max.x()),
+                Math.min(min.y(), max.y()),
+                Math.min(min.z(), max.z()),
+                Math.max(min.x(), max.x()),
+                Math.max(min.y(), max.y()),
+                Math.max(min.z(), max.z())
             );
         }
     }
@@ -823,13 +790,14 @@ public class World implements MutableWorldSource {
         this.markBlocksDirty(new TilePos(minX, minY, minZ), new TilePos(maxX, maxY, maxZ));
     }
 
-    public void notifyBlocksOfNeighborChange(final @NotNull TilePos tilePos, final int id) {
-        this.notifyBlockOfNeighborChange(tilePos.west(), id);
-        this.notifyBlockOfNeighborChange(tilePos.east(), id);
-        this.notifyBlockOfNeighborChange(tilePos.down(), id);
-        this.notifyBlockOfNeighborChange(tilePos.up(), id);
-        this.notifyBlockOfNeighborChange(tilePos.north(), id);
-        this.notifyBlockOfNeighborChange(tilePos.south(), id);
+    public void notifyBlocksOfNeighborChange(final @NotNull TilePosc tilePos, final int id) {
+        TilePos queryPos = new TilePos();
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.WEST, queryPos), id);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.EAST, queryPos), id);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.DOWN, queryPos), id);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.UP, queryPos), id);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.NORTH, queryPos), id);
+        this.notifyBlockOfNeighborChange(tilePos.add(Direction.SOUTH, queryPos), id);
     }
 
     @Deprecated
@@ -837,18 +805,18 @@ public class World implements MutableWorldSource {
         this.notifyBlocksOfNeighborChange(new TilePos(x, y, z), id);
     }
 
-    private void notifyBlockOfNeighborChange(final @NotNull TilePos tilePos, final int id) {
+    private void notifyBlockOfNeighborChange(final @NotNull TilePosc tilePos, final int id) {
         if (this.noNeighborUpdate || this.isClientSide) {
             return;
         }
         final @Nullable Block<?> block = this.getBlock(tilePos);
         if (block != null) {
-            block.onNeighborBlockChange(this, tilePos.x, tilePos.y, tilePos.z, id);
+            block.onNeighborChanged(this, tilePos, id);
         }
     }
 
-    public boolean canBlockSeeSky(final @NotNull TilePos tilePos) {
-        return this.getChunk(tilePos).canBlockSeeSky(tilePos.toChunkTilePos());
+    public boolean canBlockSeeSky(final @NotNull TilePosc tilePos) {
+        return this.getChunk(tilePos).canBlockSeeSky(new ChunkTilePos(tilePos));
     }
 
     @Deprecated
@@ -856,11 +824,11 @@ public class World implements MutableWorldSource {
         return this.canBlockSeeSky(new TilePos(x, y, z));
     }
 
-    public int getFullBlockLightValue(final @NotNull TilePos tilePos) {
-        if (tilePos.y < 0) {
+    public int getFullBlockLightValue(final @NotNull TilePosc tilePos) {
+        if (tilePos.y() < 0) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getRawBrightness(new TilePos(tilePos.x, Math.min(tilePos.y, this.getHeightBlocks() - 1), tilePos.z).toChunkTilePos(), 0);
+            return this.getChunk(tilePos).getRawBrightness(new ChunkTilePos(new TilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z())), 0);
         }
     }
 
@@ -869,7 +837,7 @@ public class World implements MutableWorldSource {
         return this.getFullBlockLightValue(new TilePos(x, y, z));
     }
 
-    public int getBlockLightValue(final @NotNull TilePos tilePos) {
+    public int getBlockLightValue(final @NotNull TilePosc tilePos) {
         return this.getBlockLightValue_do(tilePos, true);
     }
 
@@ -878,30 +846,31 @@ public class World implements MutableWorldSource {
         return this.getBlockLightValue(new TilePos(x, y, z));
     }
 
-    private int getBlockLightValue_do(final @NotNull TilePos tilePos, final boolean first) {
-        if (tilePos.x < MIN_BLOCK_X || tilePos.z < MIN_BLOCK_Z || tilePos.x > MAX_BLOCK_X || tilePos.z > MAX_BLOCK_Z) {
+    private int getBlockLightValue_do(final @NotNull TilePosc tilePos, final boolean first) {
+        if (!tilePos.inBounds(this)) {
             return MAX_BRIGHTNESS;
         }
 
         if (first) {
             if (this.getBlockLitInteriorSurface(tilePos)) {
-                final int lightUp = this.getBlockLightValue_do(tilePos.up(), false);
-                final int lightEast = this.getBlockLightValue_do(tilePos.east(), false);
-                final int lightWest = this.getBlockLightValue_do(tilePos.west(), false);
-                final int lightSouth = this.getBlockLightValue_do(tilePos.south(), false);
-                final int lightNorth = this.getBlockLightValue_do(tilePos.north(), false);
+                TilePos queryPos = new TilePos();
+                final int lightUp = this.getBlockLightValue_do(tilePos.add(Direction.UP, queryPos), false);
+                final int lightEast = this.getBlockLightValue_do(tilePos.add(Direction.EAST, queryPos), false);
+                final int lightWest = this.getBlockLightValue_do(tilePos.add(Direction.WEST, queryPos), false);
+                final int lightSouth = this.getBlockLightValue_do(tilePos.add(Direction.SOUTH, queryPos), false);
+                final int lightNorth = this.getBlockLightValue_do(tilePos.add(Direction.NORTH, queryPos), false);
                 return Math.max(lightUp, Math.max(lightEast, Math.max(lightWest, Math.max(lightSouth, lightNorth))));
             }
         }
 
-        if (tilePos.y < 0) {
+        if (tilePos.y() < 0) {
             return 0;
         }
-        return this.getChunk(tilePos).getRawBrightness(new TilePos(tilePos.x, Math.min(tilePos.y, this.getHeightBlocks() - 1), tilePos.z).toChunkTilePos(), this.skyDarken);
+        return this.getChunk(tilePos).getRawBrightness(new ChunkTilePos(new TilePos(tilePos.x(), Math.min(tilePos.y(), this.getHeightBlocks() - 1), tilePos.z())), this.skyDarken);
     }
 
-    public boolean canLoadedBlockSeeSky(final @NotNull TilePos tilePos) {
-        if (tilePos.y >= this.getHeightBlocks()) {
+    public boolean canLoadedBlockSeeSky(final @NotNull TilePosc tilePos) {
+        if (tilePos.y() >= this.getHeightBlocks()) {
             return true;
         } else if (!tilePos.inBounds(this)) {
             return false;
@@ -909,7 +878,7 @@ public class World implements MutableWorldSource {
             return false;
         }
 
-        return this.getChunk(tilePos).canBlockSeeSky(tilePos.toChunkTilePos());
+        return this.getChunk(tilePos).canBlockSeeSky(new ChunkTilePos(tilePos));
     }
 
     @Deprecated
@@ -921,9 +890,9 @@ public class World implements MutableWorldSource {
         if (x < World.MIN_BLOCK_X || z < World.MIN_BLOCK_Z || x > World.MAX_BLOCK_X || z > World.MAX_BLOCK_Z) {
             return 0;
         }
-        final @NotNull TilePos tilePos = new TilePos(x, 0, z);
 
-        if (!this.isBlockLoaded(new TilePos(x, 0, z))) {
+        final @NotNull TilePos tilePos = new TilePos(x, 0, z);
+        if (!this.isBlockLoaded(tilePos)) {
             return 0;
         } else {
             return this.getChunk(tilePos).getHeightValue(x & (Chunk.CHUNK_SIZE_X - 1), z & (Chunk.CHUNK_SIZE_Z - 1));
@@ -931,13 +900,13 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos) {
+    public int getSavedLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos) {
         if (!tilePos.inBounds(this)) {
             return lightLayer.defaultLightLevel;
         } else if (!this.isBlockLoaded(tilePos)) {
             return 0;
         } else {
-            return this.getChunk(tilePos).getBrightness(lightLayer, tilePos.toChunkTilePos());
+            return this.getChunk(tilePos).getBrightness(lightLayer, new ChunkTilePos(tilePos));
         }
     }
 
@@ -947,40 +916,41 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePos tilePos, final int value) {
+    public void setLightValue(final @NotNull LightLayer lightLayer, final @NotNull TilePosc tilePos, final int value) {
         if (tilePos.inBounds(this) && this.isBlockLoaded(tilePos)) {
-            this.getChunk(tilePos).setBrightness(lightLayer, tilePos.toChunkTilePos(), value);
+            this.getChunk(tilePos).setBrightness(lightLayer, new ChunkTilePos(tilePos), value);
             for (final @NotNull LevelListener listener : this.listeners) {
-                listener.blockChanged(tilePos.x, tilePos.y, tilePos.z);
+                listener.blockChanged(tilePos.x(), tilePos.y(), tilePos.z());
             }
         }
     }
 
     @Override
-    public float getBrightness(final @NotNull TilePos tilePos, final int lightEmission) {
+    public float getBrightness(final @NotNull TilePosc tilePos, final int lightEmission) {
         final int lightValue = this.getBlockLightValue(tilePos);
         return this.worldType.getBrightnessRamp()[Math.max(lightValue, lightEmission)];
     }
 
     @Override
-    public int getLightmapCoord(final @NotNull TilePos tilePos, final int lightEmission) {
+    public int getLightmapCoord(final @NotNull TilePosc tilePos, final int lightEmission) {
         int skyLight = this.getSavedLightValue(LightLayer.Sky, tilePos);
         int blockLight = Math.max(this.getSavedLightValue(LightLayer.Block, tilePos), lightEmission);
 
         if (this.getBlockLitInteriorSurface(tilePos)) {
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.up()));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.down()));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.east()));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.west()));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.south()));
-            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.north()));
-
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.up()));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.down()));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.east()));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.west()));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.south()));
-            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.north()));
+            TilePos queryPos = new TilePos();
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.UP, queryPos)));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.DOWN, queryPos)));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.EAST, queryPos)));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.WEST, queryPos)));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.SOUTH, queryPos)));
+            skyLight = Math.max(skyLight, this.getSavedLightValue(LightLayer.Sky, tilePos.add(Direction.NORTH, queryPos)));
+
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.UP, queryPos)));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.DOWN, queryPos)));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.EAST, queryPos)));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.WEST, queryPos)));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.SOUTH, queryPos)));
+            blockLight = Math.max(blockLight, this.getSavedLightValue(LightLayer.Block, tilePos.add(Direction.NORTH, queryPos)));
         }
 
         return this.getLightmapCoord(skyLight, blockLight);
@@ -992,7 +962,7 @@ public class World implements MutableWorldSource {
     }
 
     @Override
-    public float getLightBrightness(final @NotNull TilePos tilePos) {
+    public float getLightBrightness(final @NotNull TilePosc tilePos) {
         return this.worldType.getBrightnessRamp()[this.getBlockLightValue(tilePos)];
     }
 
@@ -1000,56 +970,43 @@ public class World implements MutableWorldSource {
         return this.skyDarken < 4;
     }
 
-    public @Nullable HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end)
-    {
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull Vector3dc start, @NotNull Vector3dc end) {
         return checkBlockCollisionBetweenPoints(start, end, false, false, false);
     }
 
 
-    public @Nullable HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids)
-    {
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull Vector3dc start, @NotNull Vector3dc end, boolean shouldCollideWithFluids) {
         return checkBlockCollisionBetweenPoints(start, end, shouldCollideWithFluids, false, false);
     }
 
-    public @Nullable HitResult checkBlockCollisionBetweenPoints(Vec3 start, Vec3 end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes)
-    {
-        if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
-        {
+    public @Nullable HitResult checkBlockCollisionBetweenPoints(@NotNull Vector3dc start, @NotNull Vector3dc end, boolean shouldCollideWithFluids, boolean ignoreNonColliderBlocks, boolean useSelectorBoxes) {
+        if (!start.isFinite()) {
             return null;
         }
-        if(Double.isNaN(end.x) || Double.isNaN(end.y) || Double.isNaN(end.z))
-        {
+        if (!end.isFinite()) {
             return null;
         }
-        int blockEndX = MathHelper.floor(end.x);
-        int blockEndY = MathHelper.floor(end.y);
-        int blockEndZ = MathHelper.floor(end.z);
-        int blockStartX = MathHelper.floor(start.x);
-        int blockStartY = MathHelper.floor(start.y);
-        int blockStartZ = MathHelper.floor(start.z);
-        int id = getBlockId(blockStartX, blockStartY, blockStartZ);
-        int meta = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
+        Vector3d start2 = new Vector3d(start);
+        Vector3d end2 = new Vector3d(end);
+        TilePos blockEnd = new TilePos(end2);
+        TilePos blockStart = new TilePos(start2);
+        int id = getBlockId(blockStart);
+        int meta = getBlockData(blockStart);
         Block<?> block = Blocks.blocksList[id];
-        if(
-            (
-                !ignoreNonColliderBlocks ||
-                    (block == null) ||
-                    ((useSelectorBoxes ? block.getSelectedBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) : block.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ)) != null)) && (id > 0) && (block.canCollideCheck(meta, shouldCollideWithFluids)))
-        {
-            HitResult hitResult = block.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end, useSelectorBoxes);
-            if(hitResult != null)
-            {
+        if (
+            (!ignoreNonColliderBlocks ||
+                (block == null) ||
+                ((useSelectorBoxes ? block.getSelectionAABB(this, blockStart) : block.getCollisionAABB(this, blockStart)) != null)) && (id > 0) && (block != null && block.canCollideCheck(meta, shouldCollideWithFluids))) {
+            HitResult hitResult = block.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
+            if (hitResult != null) {
                 return hitResult;
             }
         }
-        for(int l1 = 200; l1-- >= 0;)
-        {
-            if(Double.isNaN(start.x) || Double.isNaN(start.y) || Double.isNaN(start.z))
-            {
+        for (int l1 = 200; l1-- >= 0; ) {
+            if (!start2.isFinite()) {
                 return null;
             }
-            if(blockStartX == blockEndX && blockStartY == blockEndY && blockStartZ == blockEndZ)
-            {
+            if (blockStart.equals(blockEnd)) {
                 return null;
             }
             boolean flag2 = true;
@@ -1058,123 +1015,93 @@ public class World implements MutableWorldSource {
             double d = 999D;
             double d1 = 999D;
             double d2 = 999D;
-            if(blockEndX > blockStartX)
-            {
-                d = (double)blockStartX + 1.0D;
-            } else
-            if(blockEndX < blockStartX)
-            {
-                d = (double)blockStartX + 0.0D;
-            } else
-            {
+            if (blockEnd.x > blockStart.x) {
+                d = (double) blockStart.x + 1.0D;
+            } else if (blockEnd.x < blockStart.x) {
+                d = (double) blockStart.x + 0.0D;
+            } else {
                 flag2 = false;
             }
-            if(blockEndY > blockStartY)
-            {
-                d1 = (double)blockStartY + 1.0D;
-            } else
-            if(blockEndY < blockStartY)
-            {
-                d1 = (double)blockStartY + 0.0D;
-            } else
-            {
+            if (blockEnd.y > blockStart.y) {
+                d1 = (double) blockStart.y + 1.0D;
+            } else if (blockEnd.y < blockStart.y) {
+                d1 = (double) blockStart.y + 0.0D;
+            } else {
                 flag3 = false;
             }
-            if(blockEndZ > blockStartZ)
-            {
-                d2 = (double)blockStartZ + 1.0D;
-            } else
-            if(blockEndZ < blockStartZ)
-            {
-                d2 = (double)blockStartZ + 0.0D;
-            } else
-            {
+            if (blockEnd.z > blockStart.z) {
+                d2 = (double) blockStart.z + 1.0D;
+            } else if (blockEnd.z < blockStart.z) {
+                d2 = (double) blockStart.z + 0.0D;
+            } else {
                 flag4 = false;
             }
             double d3 = 999D;
             double d4 = 999D;
             double d5 = 999D;
-            double d6 = end.x - start.x;
-            double d7 = end.y - start.y;
-            double d8 = end.z - start.z;
-            if(flag2)
-            {
-                d3 = (d - start.x) / d6;
+            double d6 = end2.x - start2.x;
+            double d7 = end2.y - start2.y;
+            double d8 = end2.z - start2.z;
+            if (flag2) {
+                d3 = (d - start2.x) / d6;
             }
-            if(flag3)
-            {
-                d4 = (d1 - start.y) / d7;
+            if (flag3) {
+                d4 = (d1 - start2.y) / d7;
             }
-            if(flag4)
-            {
-                d5 = (d2 - start.z) / d8;
+            if (flag4) {
+                d5 = (d2 - start2.z) / d8;
             }
             byte byte0 = 0;
-            if(d3 < d4 && d3 < d5)
-            {
-                if(blockEndX > blockStartX)
-                {
+            if (d3 < d4 && d3 < d5) {
+                if (blockEnd.x > blockStart.x) {
                     byte0 = 4;
-                } else
-                {
+                } else {
                     byte0 = 5;
                 }
-                start.x = d;
-                start.y += d7 * d3;
-                start.z += d8 * d3;
-            } else
-            if(d4 < d5)
-            {
-                if(blockEndY > blockStartY)
-                {
+                start2.x = d;
+                start2.y += d7 * d3;
+                start2.z += d8 * d3;
+            } else if (d4 < d5) {
+                if (blockEnd.y > blockStart.y) {
                     byte0 = 0;
-                } else
-                {
+                } else {
                     byte0 = 1;
                 }
-                start.x += d6 * d4;
-                start.y = d1;
-                start.z += d8 * d4;
-            } else
-            {
-                if(blockEndZ > blockStartZ)
-                {
+                start2.x += d6 * d4;
+                start2.y = d1;
+                start2.z += d8 * d4;
+            } else {
+                if (blockEnd.z > blockStart.z) {
                     byte0 = 2;
-                } else
-                {
+                } else {
                     byte0 = 3;
                 }
-                start.x += d6 * d5;
-                start.y += d7 * d5;
-                start.z = d2;
-            }
-            Vec3 vec32 = Vec3.fromPool(start.x, start.y, start.z);
-            blockStartX = (int)(vec32.x = MathHelper.floor(start.x));
-            if(byte0 == 5)
-            {
-                blockStartX--;
-                vec32.x++;
-            }
-            blockStartY = (int)(vec32.y = MathHelper.floor(start.y));
-            if(byte0 == 1)
-            {
-                blockStartY--;
-                vec32.y++;
-            }
-            blockStartZ = (int)(vec32.z = MathHelper.floor(start.z));
-            if(byte0 == 3)
-            {
-                blockStartZ--;
-                vec32.z++;
-            }
-            Block<?> block1 = getBlock(blockStartX, blockStartY, blockStartZ);
-            int metadata1 = getBlockMetadata(blockStartX, blockStartY, blockStartZ);
-            if(
-                (!ignoreNonColliderBlocks || (block1 == null) || ((useSelectorBoxes ? block1.getSelectedBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ) : block1.getCollisionBoundingBoxFromPool(this, blockStartX, blockStartY, blockStartZ)) != null)) && (block1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids))
-            {
-                HitResult hitResult = block1.collisionRayTrace(this, blockStartX, blockStartY, blockStartZ, start, end, useSelectorBoxes);
-                if(hitResult != null)
-                {
+                start2.x += d6 * d5;
+                start2.y += d7 * d5;
+                start2.z = d2;
+            }
+            Vector3d startCopy = new Vector3d(start2);
+            blockStart.x = (int) (startCopy.x = MathHelper.floor(start2.x()));
+            if (byte0 == 5) {
+                blockStart.x--;
+                startCopy.x++;
+            }
+            blockStart.y = (int) (startCopy.y = MathHelper.floor(start2.y()));
+            if (byte0 == 1) {
+                blockStart.y--;
+                startCopy.y++;
+            }
+            blockStart.z = (int) (startCopy.z = MathHelper.floor(start2.z()));
+            if (byte0 == 3) {
+                blockStart.z--;
+                startCopy.z++;
+            }
+            Block<?> block1 = getBlock(blockStart);
+            int metadata1 = getBlockData(blockStart);
+            if (
+                (!ignoreNonColliderBlocks || (block1 == null) || ((useSelectorBoxes ? block1.getSelectionAABB(this, blockStart) : block1.getCollisionAABB(this, blockStart)) != null)) && (block1 != null) && block1.canCollideCheck(metadata1, shouldCollideWithFluids)) {
+                HitResult hitResult = block1.collisionRayTrace(this, blockStart, start2, end2, useSelectorBoxes);
+                if (hitResult != null) {
                     return hitResult;
                 }
             }
@@ -1182,39 +1109,31 @@ public class World implements MutableWorldSource {
 
         return null;
     }
-    
-    public void playSoundAtEntity(@Nullable Entity player, @NotNull Entity entity, String soundPath, float volume, float pitch)
-    {
-        for (LevelListener listener : listeners)
-        {
+
+    public void playSoundAtEntity(@Nullable Entity player, @NotNull Entity entity, String soundPath, float volume, float pitch) {
+        for (LevelListener listener : this.listeners) {
             listener.playSound(player, soundPath, SoundCategory.ENTITY_SOUNDS, entity.x, entity.y - (double) entity.heightOffset, entity.z, volume, pitch);
         }
 
     }
-    
+
     public void playSoundEffect(@Nullable Entity player, SoundCategory category, double x, double y, double z, String soundPath,
-                                float volume, float pitch)
-    {
-        for (LevelListener listener : listeners)
-        {
+                                float volume, float pitch) {
+        for (LevelListener listener : this.listeners) {
             listener.playSound(player, soundPath, category, x, y, z, volume, pitch);
         }
     }
-    
-    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, Block<?> block, EnumBlockSoundEffectType soundType)
-    {
+
+    public void playBlockSoundEffect(@Nullable Entity player, double x, double y, double z, Block<?> block, EnumBlockSoundEffectType soundType) {
         if (block == null) return;
 
         BlockSound sound = block.getSound();
         if (sound == null) return;
 
         String name;
-        if (soundType == EnumBlockSoundEffectType.MINE)
-        {
+        if (soundType == EnumBlockSoundEffectType.MINE) {
             name = sound.getBreakSoundName();
-        }
-        else
-        {
+        } else {
             name = sound.getStepSoundName();
         }
 
@@ -1222,7 +1141,7 @@ public class World implements MutableWorldSource {
     }
 
     public void playRecord(final @Nullable String soundPath, final @Nullable String author, final @NotNull TilePos tilePos) {
-        for (final @NotNull LevelListener listener : listeners) {
+        for (final @NotNull LevelListener listener : this.listeners) {
             listener.playStreamingMusic(soundPath, author, tilePos.x, tilePos.y, tilePos.z);
         }
     }
